/* 
 * License: MIT
 */
#include "freertos/FreeRTOS.h"
#include "freertos/task.h"
#include "driver/gpio.h"

static int prev_val = 0;
static int act_val = 0;

static short int cnt_rot = 0;
static unsigned char st_rot = 0;
static int lkp_tbl[] = {0,-1,1,0,1,0,0,-1,-1,0,0,1,0,1,-1,0};

void init_rotbtn(void)
{
    prev_val = 0;
    act_val = 0;
    cnt_rot = 0;
    st_rot = 0;

    gpio_pad_select_gpio(GPIO_NUM_36);
    gpio_set_direction(GPIO_NUM_36, GPIO_MODE_INPUT);
    gpio_pad_select_gpio(GPIO_NUM_39);
    gpio_set_direction(GPIO_NUM_39, GPIO_MODE_INPUT);
    gpio_pad_select_gpio(GPIO_NUM_34);
    gpio_set_direction(GPIO_NUM_34, GPIO_MODE_INPUT);
    gpio_pad_select_gpio(GPIO_NUM_35);
    gpio_set_direction(GPIO_NUM_35, GPIO_MODE_INPUT);
    gpio_pad_select_gpio(GPIO_NUM_33);
    gpio_set_direction(GPIO_NUM_33, GPIO_MODE_INPUT);
    gpio_pullup_dis(GPIO_NUM_33);
    gpio_pulldown_dis(GPIO_NUM_33);  
}


unsigned int poll_rotbtn(void)
{
    act_val = gpio_get_level(GPIO_NUM_36);
    act_val <<= 1;
    act_val |= gpio_get_level(GPIO_NUM_33);
    act_val <<= 1;
    act_val |= gpio_get_level(GPIO_NUM_35);
    act_val <<= 1;
    act_val |= gpio_get_level(GPIO_NUM_34);
    act_val <<= 1;
    act_val |= gpio_get_level(GPIO_NUM_39);

    st_rot |= act_val & 0x03;
    cnt_rot -= lkp_tbl[st_rot];
    st_rot = (st_rot & 0x03) << 0x02;

    if ((act_val - prev_val) != 0)
        return((act_val << 16) | cnt_rot);
    else
        return(0);
}

 
